
{
	These are the functions you'll need to do trigonometric and
exponential work with PCQ.  The mathtrans.library requires the
mathffp.library, but you won't have to worry about that since all
PCQ programs open the mathffp.library.
	In order to use any of these routines, you'll have to call
OpenMathTrans() to open the library.  Mathtrans.library is not
normally in memory, so Exec will have to load it from the LIBS:
directory.  OpenMathTrans() just makes the appropriate
OpenLibrary() call, by the way.  Nothing fancy.
	When you are through with these routines, you'll need to
close the library.  Normally you would just use CloseMathTrans,
which just calls CloseLibrary() for you.  Instead, you can use
FlushMathTrans, which will close the library, and also remove it
from memory.  Remember, use one of these routines, but not both.
Also remember that the library will be removed from memory only if
no programs are using it.  If the library is not removed, chances
are it was one of your programs that forgot to close it (that is,
by the way, the reason we have to close libraries).

}


Function OpenMathTrans(): Boolean;
    External;
Procedure CloseMathTrans;
    External;
Procedure FlushMathTrans;
    External;
Function SPAsin(r : real): real;
    External;
Function SPAcos(r : real): real;
    External;
Function SPAtan(r : real): real;
    External;
Function SPSin(r : real): real;
    External;
Function SPCos(r : real): real;
    External;
Function SPTan(r : real): real;
    External;
Function SPSincos(var c : real; r : real): real;
    External;

{  SPSincos returns the sine value, and puts the cosine in the
   variable in c }

Function SPSinh(r : real): real;
    External;
Function SPCosh(r : real): real;
    External;
Function SPTanh(r : real): real;
    External;
Function SPExp(r : real): real;
    External;
Function SPLog(r : real): real;
    External;
Function SPLog10(r : real): real;
    External;
Function SPPow(b, e : real): real;
    External;
Function SPSqrt(r : real): real;
    External;
Function SPTieee(r : real): real;
    External;
Function SPFieee(r : real): real;
    External;

{ The last two functions convert to and from IEEE real numbers.  Although
  it says here that SPTieee returns a real number, the format is
  inconsistent with with FFP format used by the rest of the math routines }

