{
	Views.i

	This file just defines the View and ViewPort structures,
	along with several related structures and constants.
}

{$I "Include/Copper.i"}

Type
    ColorMap = Record
	Flags,
	CType	: Byte; { in C programs this is called Type }
	Count	: Short;
	ColorTable : Address;
    end;
    ColorMapPtr = ^ColorMap;

{ if CType = 0 then ColorTable is a table of Shorts xRGB }

    RasInfo = Record	{ used by callers to and InitDspC() }
	Next	: ^RasInfo;	    { used for dualpf }
	BitMap	: Address;
	RxOffset,
	RyOffset : Short;	    { scroll offsets in this BitMap }
    end;
    RasInfoPtr = ^RasInfo;

    ViewPort = Record
	Next	: ^ViewPort;
	ColorMap	: ColorMapPtr;
		  { if this is nil, MakeVPort assumes default values }
	DspIns	: CopListPtr;	{ used by MakeView() }
	SprIns	: CopListPtr;	{ used by sprite stuff }
	ClrIns	: CopListPtr;	{ used by sprite stuff }
	UCopIns	: UCopListPtr;	    { User copper list }
	DWidth,
	DHeight	: Short;
	DxOffset,
	DyOffset : Short;
	Modes	: Short;
	SpritePriorities	: Byte;		{ used by makevp }
	reserved	: Byte;
	RasInfo	: RasInfoPtr;
    end;
    ViewPortPtr = ^ViewPort;

    View = Record
	ViewPort : ViewPortPtr;
	LOFCprList	: CprListPtr;	{ used for interlaced and noninterlaced }
	SHFCprList	: CprListPtr;	{ only used during interlace }
	DyOffset,
	DxOffset	: Short;   { for complete View positioning }
			      { offsets are +- adjustments to standard #s }
	Modes	: Short;	      { such as INTERLACE, GENLOC }
    end;
    ViewPtr = ^View;

{ definitions used for Modes in IVPargs }
Const
    PFBA	= $40;
    DUALPF	= $400;
    HIRES	= $8000;
    LACE	= 4;
    HAM		= $800;
    SPRITES	= $4000;	    { reuse one of plane ctr bits }
    VP_HIDE	= $2000;	    { reuse another plane crt bit }
    GENLOCK_AUDIO	= $100;
    GENLOCK_VIDEO	= $2;
    EXTRA_HALFBRITE	= $80;

